delete trailing whitespace from control files
[debian/gzip] / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2018 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program.  If not, see <https://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Helper variables.
25 _empty =
26 _sp = $(_empty) $(_empty)
27
28 # _equal,S1,S2
29 # ------------
30 # If S1 == S2, return S1, otherwise the empty string.
31 _equal = $(and $(findstring $(1),$(2)),$(findstring $(2),$(1)))
32
33 # member-check,VARIABLE,VALID-VALUES
34 # ----------------------------------
35 # Check that $(VARIABLE) is in the space-separated list of VALID-VALUES, and
36 # return it.  Die otherwise.
37 member-check =                                                          \
38   $(strip                                                               \
39     $(if $($(1)),                                                       \
40       $(if $(findstring $(_sp),$($(1))),                                \
41           $(error invalid $(1): '$($(1))', expected $(2)),              \
42           $(or $(findstring $(_sp)$($(1))$(_sp),$(_sp)$(2)$(_sp)),      \
43             $(error invalid $(1): '$($(1))', expected $(2)))),          \
44       $(error $(1) undefined)))
45
46 # Do not save the original name or timestamp in the .tar.gz file.
47 # Use --rsyncable if available.
48 gzip_rsyncable := \
49   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
50     && printf %s --rsyncable)
51 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
52
53 GIT = git
54 VC = $(GIT)
55
56 VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
57
58 # You can override this variable in cfg.mk if your gnulib submodule lives
59 # in a different location.
60 gnulib_dir ?= $(srcdir)/gnulib
61
62 # You can override this variable in cfg.mk to set your own regexp
63 # matching files to ignore.
64 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
65
66 # This is to preprocess robustly the output of $(VC_LIST), so that even
67 # when $(srcdir) is a pathological name like "....", the leading sed command
68 # removes only the intended prefix.
69 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
70
71 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
72 # when $(srcdir) is not ".".
73 ifeq ($(srcdir),.)
74   _prepend_srcdir_prefix =
75 else
76   _prepend_srcdir_prefix = | $(SED) 's|^|$(srcdir)/|'
77 endif
78
79 # In order to be able to consistently filter "."-relative names,
80 # (i.e., with no $(srcdir) prefix), this definition is careful to
81 # remove any $(srcdir) prefix, and to restore what it removes.
82 _sc_excl = \
83   $(or $(exclude_file_name_regexp--$@),^$$)
84 VC_LIST_EXCEPT = \
85   $(VC_LIST) | $(SED) 's|^$(_dot_escaped_srcdir)/||' \
86         | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
87           else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
88         | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
89         $(_prepend_srcdir_prefix)
90
91 ifeq ($(origin prev_version_file), undefined)
92   prev_version_file = $(srcdir)/.prev-version
93 endif
94
95 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
96 VERSION_REGEXP = $(subst .,\.,$(VERSION))
97 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
98
99 ifeq ($(VC),$(GIT))
100   this-vc-tag = v$(VERSION)
101   this-vc-tag-regexp = v$(VERSION_REGEXP)
102 else
103   tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
104   tag-this-version = $(subst .,_,$(VERSION))
105   this-vc-tag = $(tag-package)-$(tag-this-version)
106   this-vc-tag-regexp = $(this-vc-tag)
107 endif
108 my_distdir = $(PACKAGE)-$(VERSION)
109
110 # Old releases are stored here.
111 release_archive_dir ?= ../release
112
113 # If RELEASE_TYPE is undefined, but RELEASE is, use its second word.
114 # But overwrite VERSION.
115 ifdef RELEASE
116   VERSION := $(word 1, $(RELEASE))
117   RELEASE_TYPE ?= $(word 2, $(RELEASE))
118 endif
119
120 # Validate and return $(RELEASE_TYPE), or die.
121 RELEASE_TYPES = alpha beta stable
122 release-type = $(call member-check,RELEASE_TYPE,$(RELEASE_TYPES))
123
124 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
125 # Use alpha.gnu.org for alpha and beta releases.
126 # Use ftp.gnu.org for stable releases.
127 gnu_ftp_host-alpha = alpha.gnu.org
128 gnu_ftp_host-beta = alpha.gnu.org
129 gnu_ftp_host-stable = ftp.gnu.org
130 gnu_rel_host ?= $(gnu_ftp_host-$(release-type))
131
132 url_dir_list ?= $(if $(call _equal,$(gnu_rel_host),ftp.gnu.org),        \
133                      https://ftpmirror.gnu.org/$(PACKAGE),              \
134                      https://$(gnu_rel_host)/gnu/$(PACKAGE))
135
136 # Override this in cfg.mk if you are using a different format in your
137 # NEWS file.
138 today = $(shell date +%Y-%m-%d)
139
140 # Select which lines of NEWS are searched for $(news-check-regexp).
141 # This is a sed line number spec.  The default says that we search
142 # lines 1..10 of NEWS for $(news-check-regexp).
143 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
144 news-check-lines-spec ?= 1,10
145 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
146
147 # Prevent programs like 'sort' from considering distinct strings to be equal.
148 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
149 export LC_ALL = C
150
151 ## --------------- ##
152 ## Sanity checks.  ##
153 ## --------------- ##
154
155 ifneq ($(_gl-Makefile),)
156 _cfg_mk := $(wildcard $(srcdir)/cfg.mk)
157
158 # Collect the names of rules starting with 'sc_'.
159 syntax-check-rules := $(sort $(shell $(SED) -n \
160    's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(srcdir)/$(ME) $(_cfg_mk)))
161 .PHONY: $(syntax-check-rules)
162
163 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
164   local-checks-available += $(syntax-check-rules)
165 else
166   local-checks-available += no-vc-detected
167 no-vc-detected:
168         @echo "No version control files detected; skipping syntax check"
169 endif
170 .PHONY: $(local-checks-available)
171
172 # Arrange to print the name of each syntax-checking rule just before running it.
173 $(syntax-check-rules): %: %.m
174 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
175 .PHONY: $(sc_m_rules_)
176 $(sc_m_rules_):
177         @echo $(patsubst sc_%.m, %, $@)
178         @date +%s.%N > .sc-start-$(basename $@)
179
180 # Compute and print the elapsed time for each syntax-check rule.
181 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
182 .PHONY: $(sc_z_rules_)
183 $(sc_z_rules_): %.z: %
184         @end=$$(date +%s.%N);                                           \
185         start=$$(cat .sc-start-$*);                                     \
186         rm -f .sc-start-$*;                                             \
187         awk -v s=$$start -v e=$$end                                     \
188           'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
189
190 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
191 # that computes and prints elapsed time.
192 local-check :=                                                          \
193   $(patsubst sc_%, sc_%.z,                                              \
194     $(filter-out $(local-checks-to-skip), $(local-checks-available)))
195
196 syntax-check: $(local-check)
197 endif
198
199 # _sc_search_regexp
200 #
201 # This macro searches for a given construct in the selected files and
202 # then takes some action.
203 #
204 # Parameters (shell variables):
205 #
206 #  prohibit | require
207 #
208 #     Regular expression (ERE) denoting either a forbidden construct
209 #     or a required construct.  Those arguments are exclusive.
210 #
211 #  exclude
212 #
213 #     Regular expression (ERE) denoting lines to ignore that matched
214 #     a prohibit construct.  For example, this can be used to exclude
215 #     comments that mention why the nearby code uses an alternative
216 #     construct instead of the simpler prohibited construct.
217 #
218 #  in_vc_files | in_files
219 #
220 #     grep-E-style regexp selecting the files to check.  For in_vc_files,
221 #     the regexp is used to select matching files from the list of all
222 #     version-controlled files; for in_files, it's from the names printed
223 #     by "find $(srcdir)".  When neither is specified, use all files that
224 #     are under version control.
225 #
226 #  containing | non_containing
227 #
228 #     Select the files (non) containing strings matching this regexp.
229 #     If both arguments are specified then CONTAINING takes
230 #     precedence.
231 #
232 #  with_grep_options
233 #
234 #     Extra options for grep.
235 #
236 #  ignore_case
237 #
238 #     Ignore case.
239 #
240 #  halt
241 #
242 #     Message to display before to halting execution.
243 #
244 # Finally, you may exempt files based on an ERE matching file names.
245 # For example, to exempt from the sc_space_tab check all files with the
246 # .diff suffix, set this Make variable:
247 #
248 # exclude_file_name_regexp--sc_space_tab = \.diff$
249 #
250 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
251 # when filtering by name via in_files, we explicitly filter out matching
252 # names here as well.
253
254 # Initialize each, so that envvar settings cannot interfere.
255 export require =
256 export prohibit =
257 export exclude =
258 export in_vc_files =
259 export in_files =
260 export containing =
261 export non_containing =
262 export halt =
263 export with_grep_options =
264
265 # By default, _sc_search_regexp does not ignore case.
266 export ignore_case =
267 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
268
269 define _sc_say_and_exit
270    dummy=; : so we do not need a semicolon before each use;             \
271    { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
272 endef
273
274 define _sc_search_regexp
275    dummy=; : so we do not need a semicolon before each use;             \
276                                                                         \
277    : Check arguments;                                                   \
278    test -n "$$prohibit" && test -n "$$require"                          \
279      && { msg='Cannot specify both prohibit and require'                \
280           $(_sc_say_and_exit) } || :;                                   \
281    test -z "$$prohibit" && test -z "$$require"                          \
282      && { msg='Should specify either prohibit or require'               \
283           $(_sc_say_and_exit) } || :;                                   \
284    test -z "$$prohibit" && test -n "$$exclude"                          \
285      && { msg='Use of exclude requires a prohibit pattern'              \
286           $(_sc_say_and_exit) } || :;                                   \
287    test -n "$$in_vc_files" && test -n "$$in_files"                      \
288      && { msg='Cannot specify both in_vc_files and in_files'            \
289           $(_sc_say_and_exit) } || :;                                   \
290    test "x$$halt" != x                                                  \
291      || { msg='halt not defined' $(_sc_say_and_exit) };                 \
292                                                                         \
293    : Filter by file name;                                               \
294    if test -n "$$in_files"; then                                        \
295      files=$$(find $(srcdir) | grep -E "$$in_files"                     \
296               | grep -Ev '$(_sc_excl)');                                \
297    else                                                                 \
298      files=$$($(VC_LIST_EXCEPT));                                       \
299      if test -n "$$in_vc_files"; then                                   \
300        files=$$(echo "$$files" | grep -E "$$in_vc_files");              \
301      fi;                                                                \
302    fi;                                                                  \
303                                                                         \
304    : Filter by content;                                                 \
305    test -n "$$files" && test -n "$$containing"                          \
306      && { files=$$(grep -l "$$containing" $$files); } || :;             \
307    test -n "$$files" && test -n "$$non_containing"                      \
308      && { files=$$(grep -vl "$$non_containing" $$files); } || :;        \
309                                                                         \
310    : Check for the construct;                                           \
311    if test -n "$$files"; then                                           \
312      if test -n "$$prohibit"; then                                      \
313        grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
314          | grep -vE "$${exclude:-^$$}"                                  \
315          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
316      else                                                               \
317        grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
318            | grep .                                                     \
319          && { msg="$$halt" $(_sc_say_and_exit) } || :;                  \
320      fi                                                                 \
321    else :;                                                              \
322    fi || :;
323 endef
324
325 sc_avoid_if_before_free:
326         @$(srcdir)/$(_build-aux)/useless-if-before-free                 \
327                 $(useless_free_options)                                 \
328             $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) &&   \
329           { echo '$(ME): found useless "if" before "free" above' 1>&2;  \
330             exit 1; } || :
331
332 sc_cast_of_argument_to_free:
333         @prohibit='\<free *\( *\(' halt="don't cast free argument"      \
334           $(_sc_search_regexp)
335
336 sc_cast_of_x_alloc_return_value:
337         @prohibit='\*\) *x(m|c|re)alloc\>'                              \
338         halt="don't cast x*alloc return value"                          \
339           $(_sc_search_regexp)
340
341 sc_cast_of_alloca_return_value:
342         @prohibit='\*\) *alloca\>'                                      \
343         halt="don't cast alloca return value"                           \
344           $(_sc_search_regexp)
345
346 sc_space_tab:
347         @prohibit='[ ]  '                                               \
348         halt='found SPACE-TAB sequence; remove the SPACE'               \
349           $(_sc_search_regexp)
350
351 # Don't use *scanf or the old ato* functions in "real" code.
352 # They provide no error checking mechanism.
353 # Instead, use strto* functions.
354 sc_prohibit_atoi_atof:
355         @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\('                           \
356         halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q'   \
357           $(_sc_search_regexp)
358
359 # Use STREQ rather than comparing strcmp == 0, or != 0.
360 sp_ = strcmp *\(.+\)
361 sc_prohibit_strcmp:
362         @prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)'         \
363         exclude='# *define STRN?EQ\('                                   \
364         halt='replace strcmp calls above with STREQ/STRNEQ'             \
365           $(_sc_search_regexp)
366
367 # Really.  You don't want to use this function.
368 # It may fail to NUL-terminate the destination,
369 # and always NUL-pads out to the specified length.
370 sc_prohibit_strncpy:
371         @prohibit='\<strncpy *\('                                       \
372         halt='do not use strncpy, period'                               \
373           $(_sc_search_regexp)
374
375 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
376 # Convert all uses automatically, via these two commands:
377 # git grep -l '\<exit *(1)' \
378 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
379 #  | xargs --no-run-if-empty \
380 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
381 # git grep -l '\<exit *(0)' \
382 #  | grep -vEf .x-sc_prohibit_magic_number_exit \
383 #  | xargs --no-run-if-empty \
384 #      perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
385 sc_prohibit_magic_number_exit:
386         @prohibit='(^|[^.])\<(usage|exit|error) ?\(-?[0-9]+[,)]'        \
387         exclude='exit \(77\)|error ?\(((0|77),|[^,]*)'                  \
388         halt='use EXIT_* values rather than magic number'               \
389           $(_sc_search_regexp)
390
391 # Using EXIT_SUCCESS as the first argument to error is misleading,
392 # since when that parameter is 0, error does not exit.  Use '0' instead.
393 sc_error_exit_success:
394         @prohibit='error *\(EXIT_SUCCESS,'                              \
395         in_vc_files='\.[chly]$$'                                        \
396         halt='found error (EXIT_SUCCESS'                                \
397          $(_sc_search_regexp)
398
399 # "FATAL:" should be fully upper-cased in error messages
400 # "WARNING:" should be fully upper-cased, or fully lower-cased
401 sc_error_message_warn_fatal:
402         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
403             | grep -E '"Warning|"Fatal|"fatal' &&                       \
404           { echo '$(ME): use FATAL, WARNING or warning' 1>&2;           \
405             exit 1; } || :
406
407 # Error messages should not start with a capital letter
408 sc_error_message_uppercase:
409         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
410             | grep -E '"[A-Z]'                                          \
411             | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' &&           \
412           { echo '$(ME): found capitalized error message' 1>&2;         \
413             exit 1; } || :
414
415 # Error messages should not end with a period
416 sc_error_message_period:
417         @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT))              \
418             | grep -E '[^."]\."' &&                                     \
419           { echo '$(ME): found error message ending in period' 1>&2;    \
420             exit 1; } || :
421
422 sc_file_system:
423         @prohibit=file''system                                          \
424         exclude='/proc/filesystems'                                     \
425         ignore_case=1                                                   \
426         halt='found use of "file''system"; spell it "file system"'      \
427           $(_sc_search_regexp)
428
429 # Don't use cpp tests of this symbol.  All code assumes config.h is included.
430 sc_prohibit_have_config_h:
431         @prohibit='^# *if.*HAVE''_CONFIG_H'                             \
432         halt='found use of HAVE''_CONFIG_H; remove'                     \
433           $(_sc_search_regexp)
434
435 # Nearly all .c files must include <config.h>.  However, we also permit this
436 # via inclusion of a package-specific header, if cfg.mk specified one.
437 # config_h_header must be suitable for grep -E.
438 config_h_header ?= <config\.h>
439 sc_require_config_h:
440         @require='^# *include $(config_h_header)'                       \
441         in_vc_files='\.c$$'                                             \
442         halt='the above files do not include <config.h>'                \
443           $(_sc_search_regexp)
444
445 # Print each file name for which the first #include does not match
446 # $(config_h_header).  Like grep -m 1, this only looks at the first match.
447 perl_config_h_first_ =                                                  \
448   -e 'BEGIN {$$ret = 0}'                                                \
449   -e 'if (/^\# *include\b/) {'                                          \
450   -e '  if (not m{^\# *include $(config_h_header)}) {'                  \
451   -e '    print "$$ARGV\n";'                                            \
452   -e '    $$ret = 1;'                                                   \
453   -e '  }'                                                              \
454   -e '  \# Move on to next file after first include'                    \
455   -e '  close ARGV;'                                                    \
456   -e '}'                                                                \
457   -e 'END {exit $$ret}'
458
459 # You must include <config.h> before including any other header file.
460 # This can possibly be via a package-specific header, if given by cfg.mk.
461 sc_require_config_h_first:
462         @if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then          \
463           files=$$($(VC_LIST_EXCEPT) | grep '\.c$$') &&                 \
464           perl -n $(perl_config_h_first_) $$files ||                    \
465             { echo '$(ME): the above files include some other header'   \
466                 'before <config.h>' 1>&2; exit 1; } || :;               \
467         else :;                                                         \
468         fi
469
470 sc_prohibit_HAVE_MBRTOWC:
471         @prohibit='\bHAVE_MBRTOWC\b'                                    \
472         halt="do not use $$prohibit; it is always defined"              \
473           $(_sc_search_regexp)
474
475 # To use this "command" macro, you must first define two shell variables:
476 # h: the header name, with no enclosing <> or ""
477 # re: a regular expression that matches IFF something provided by $h is used.
478 define _sc_header_without_use
479   dummy=; : so we do not need a semicolon before each use;              \
480   h_esc=`echo '[<"]'"$$h"'[">]'|$(SED) 's/\./\\\\./g'`;                 \
481   if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then                 \
482     files=$$(grep -l '^# *include '"$$h_esc"                            \
483              $$($(VC_LIST_EXCEPT) | grep '\.c$$')) &&                   \
484     grep -LE "$$re" $$files | grep . &&                                 \
485       { echo "$(ME): the above files include $$h but don't use it"      \
486         1>&2; exit 1; } || :;                                           \
487   else :;                                                               \
488   fi
489 endef
490
491 # Prohibit the inclusion of assert.h without an actual use of assert.
492 sc_prohibit_assert_without_use:
493         @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
494
495 # Prohibit the inclusion of close-stream.h without an actual use.
496 sc_prohibit_close_stream_without_use:
497         @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
498
499 # Prohibit the inclusion of getopt.h without an actual use.
500 sc_prohibit_getopt_without_use:
501         @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
502
503 # Don't include quotearg.h unless you use one of its functions.
504 sc_prohibit_quotearg_without_use:
505         @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
506
507 # Don't include quote.h unless you use one of its functions.
508 sc_prohibit_quote_without_use:
509         @h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
510           $(_sc_header_without_use)
511
512 # Don't include this header unless you use one of its functions.
513 sc_prohibit_long_options_without_use:
514         @h='long-options.h' re='\<parse_long_options *\(' \
515           $(_sc_header_without_use)
516
517 # Don't include this header unless you use one of its functions.
518 sc_prohibit_inttostr_without_use:
519         @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
520           $(_sc_header_without_use)
521
522 # Don't include this header unless you use one of its functions.
523 sc_prohibit_ignore_value_without_use:
524         @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
525           $(_sc_header_without_use)
526
527 # Don't include this header unless you use one of its functions.
528 sc_prohibit_error_without_use:
529         @h='error.h' \
530         re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
531           $(_sc_header_without_use)
532
533 # Don't include xalloc.h unless you use one of its functions.
534 # Consider these symbols:
535 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
536 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
537 # Divide into two sets on case, and filter each through this:
538 # | sort | perl -MRegexp::Assemble -le \
539 #  'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
540 # Note this was produced by the above:
541 # _xa1 = \
542 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
543 # But we can do better, in at least two ways:
544 # 1) take advantage of two "dup"-suffixed strings:
545 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
546 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
547 # "char|[cmz]"
548 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
549 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
550 _xa2 = X([CZ]|N?M)ALLOC
551 sc_prohibit_xalloc_without_use:
552         @h='xalloc.h' \
553         re='\<($(_xa1)|$(_xa2)) *\('\
554           $(_sc_header_without_use)
555
556 # Extract function names:
557 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
558 _hash_re = \
559 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
560 _hash_fn = \<($(_hash_re)) *\(
561 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
562 sc_prohibit_hash_without_use:
563         @h='hash.h' \
564         re='$(_hash_fn)|$(_hash_struct)'\
565           $(_sc_header_without_use)
566
567 sc_prohibit_cloexec_without_use:
568         @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
569           $(_sc_header_without_use)
570
571 sc_prohibit_posixver_without_use:
572         @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
573
574 sc_prohibit_same_without_use:
575         @h='same.h' re='\<same_name(at)? *\(' $(_sc_header_without_use)
576
577 sc_prohibit_hash_pjw_without_use:
578         @h='hash-pjw.h' \
579         re='\<hash_pjw\>' \
580           $(_sc_header_without_use)
581
582 sc_prohibit_safe_read_without_use:
583         @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
584           $(_sc_header_without_use)
585
586 sc_prohibit_argmatch_without_use:
587         @h='argmatch.h' \
588         re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
589           $(_sc_header_without_use)
590
591 sc_prohibit_canonicalize_without_use:
592         @h='canonicalize.h' \
593         re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
594           $(_sc_header_without_use)
595
596 sc_prohibit_root_dev_ino_without_use:
597         @h='root-dev-ino.h' \
598         re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
599           $(_sc_header_without_use)
600
601 sc_prohibit_openat_without_use:
602         @h='openat.h' \
603         re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat|(FCHMOD|FCHOWN|STAT)AT_INLINE)\>' \
604           $(_sc_header_without_use)
605
606 # Prohibit the inclusion of c-ctype.h without an actual use.
607 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
608 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
609 sc_prohibit_c_ctype_without_use:
610         @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
611           $(_sc_header_without_use)
612
613 # The following list was generated by running:
614 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
615 #   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
616 _sig_functions = \
617   bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
618   sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
619   siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
620   sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
621 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
622 # The following were extracted from "man signal.h" manually.
623 _sig_types_and_consts =                                                 \
624   MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK           \
625   SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL            \
626   SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE    \
627   SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t  \
628   sigstack sigval stack_t ucontext_t
629 # generated via this:
630 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
631 _sig_names =                                                            \
632   SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT      \
633   SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL       \
634   SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP  \
635   SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR      \
636   SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS   \
637   SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1        \
638   SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW       \
639   SIGXCPU SIGXFSZ
640 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
641
642 # Prohibit the inclusion of signal.h without an actual use.
643 sc_prohibit_signal_without_use:
644         @h='signal.h'                                                   \
645         re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'          \
646           $(_sc_header_without_use)
647
648 # Don't include stdio--.h unless you use one of its functions.
649 sc_prohibit_stdio--_without_use:
650         @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\('              \
651           $(_sc_header_without_use)
652
653 # Don't include stdio-safer.h unless you use one of its functions.
654 sc_prohibit_stdio-safer_without_use:
655         @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\('    \
656           $(_sc_header_without_use)
657
658 # Prohibit the inclusion of strings.h without a sensible use.
659 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
660 sc_prohibit_strings_without_use:
661         @h='strings.h'                                                  \
662         re='\<(strn?casecmp|ffs(ll)?)\>'                                \
663           $(_sc_header_without_use)
664
665 # Extract the raw list of symbol names with this:
666 gl_extract_define_simple = \
667   /^\# *define ([A-Z]\w+)\(/ and print $$1
668 # Filter out duplicates and convert to a space-separated list:
669 _intprops_names = \
670   $(shell f=$(gnulib_dir)/lib/intprops.h;                               \
671     perl -lne '$(gl_extract_define_simple)' $$f | sort -u | tr '\n' ' ')
672 # Remove trailing space and convert to a regular expression:
673 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
674 # Prohibit the inclusion of intprops.h without an actual use.
675 sc_prohibit_intprops_without_use:
676         @h='intprops.h'                                                 \
677         re='\<($(_intprops_syms_re)) *\('                               \
678           $(_sc_header_without_use)
679
680 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
681 # Prohibit the inclusion of stddef.h without an actual use.
682 sc_prohibit_stddef_without_use:
683         @h='stddef.h'                                                   \
684         re='\<($(_stddef_syms_re))\>'                                   \
685           $(_sc_header_without_use)
686
687 _de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
688 _de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
689 _de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
690 _dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
691 # Prohibit the inclusion of dirent.h without an actual use.
692 sc_prohibit_dirent_without_use:
693         @h='dirent.h'                                                   \
694         re='\<($(_dirent_syms_re))\>'                                   \
695           $(_sc_header_without_use)
696
697 # Prohibit the inclusion of verify.h without an actual use.
698 sc_prohibit_verify_without_use:
699         @h='verify.h'                                                   \
700         re='\<(verify(true|expr)?|assume|static_assert) *\('            \
701           $(_sc_header_without_use)
702
703 # Don't include xfreopen.h unless you use one of its functions.
704 sc_prohibit_xfreopen_without_use:
705         @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
706
707 sc_obsolete_symbols:
708         @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
709         halt='do not use HAVE''_FCNTL_H or O'_NDELAY                    \
710           $(_sc_search_regexp)
711
712 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
713
714 # Each nonempty ChangeLog line must start with a year number, or a TAB.
715 sc_changelog:
716         @prohibit='^[^12        ]'                                      \
717         in_vc_files='^ChangeLog$$'                                      \
718         halt='found unexpected prefix in a ChangeLog'                   \
719           $(_sc_search_regexp)
720
721 # Ensure that each .c file containing a "main" function also
722 # calls bindtextdomain.
723 sc_bindtextdomain:
724         @require='bindtextdomain *\('                                   \
725         in_vc_files='\.c$$'                                             \
726         containing='\<main *('                                          \
727         halt='the above files do not call bindtextdomain'               \
728           $(_sc_search_regexp)
729
730 # Require that the final line of each test-lib.sh-using test be this one:
731 # Exit $fail
732 # Note: this test requires GNU grep's --label= option.
733 Exit_witness_file ?= tests/test-lib.sh
734 Exit_base := $(notdir $(Exit_witness_file))
735 sc_require_test_exit_idiom:
736         @if test -f $(srcdir)/$(Exit_witness_file); then                \
737           die=0;                                                        \
738           for i in $$(grep -l -F 'srcdir/$(Exit_base)'                  \
739                 $$($(VC_LIST) tests)); do                               \
740             tail -n1 $$i | grep '^Exit .' > /dev/null                   \
741               && : || { die=1; echo $$i; }                              \
742           done;                                                         \
743           test $$die = 1 &&                                             \
744             { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
745               echo 1>&2 'Exit something';                               \
746               exit 1; } || :;                                           \
747         fi
748
749 sc_trailing_blank:
750         @prohibit='[     ]$$'                                           \
751         halt='found trailing blank(s)'                                  \
752         exclude='^Binary file .* matches$$'                             \
753           $(_sc_search_regexp)
754
755 # Match lines like the following, but where there is only one space
756 # between the options and the description:
757 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
758 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
759 sc_two_space_separator_in_usage:
760         @prohibit='^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
761         halt='help2man requires at least two spaces between an option and its description'\
762           $(_sc_search_regexp)
763
764 # A regexp matching function names like "error" that may be used
765 # to emit translatable messages.
766 _gl_translatable_diag_func_re ?= error
767
768 # Look for diagnostics that aren't marked for translation.
769 # This won't find any for which error's format string is on a separate line.
770 sc_unmarked_diagnostics:
771         @prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
772         exclude='(_|ngettext ?)\('                                      \
773         halt='found unmarked diagnostic(s)'                             \
774           $(_sc_search_regexp)
775
776 # Avoid useless parentheses like those in this example:
777 # #if defined (SYMBOL) || defined (SYM2)
778 sc_useless_cpp_parens:
779         @prohibit='^# *if .*defined *\('                                \
780         halt='found useless parentheses in cpp directive'               \
781           $(_sc_search_regexp)
782
783 # List headers for which HAVE_HEADER_H is always true, assuming you are
784 # using the appropriate gnulib module.  CAUTION: for each "unnecessary"
785 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
786 # requires the gnulib module that guarantees the usability of that header.
787 gl_assured_headers_ = \
788   cd $(gnulib_dir)/lib && echo *.in.h|$(SED) 's/\.in\.h//g'
789
790 # Convert the list of names to upper case, and replace each space with "|".
791 az_ = abcdefghijklmnopqrstuvwxyz
792 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
793 gl_header_upper_case_or_ =                                              \
794   $$($(gl_assured_headers_)                                             \
795     | tr $(az_)/.- $(AZ_)___                                            \
796     | tr -s ' ' '|'                                                     \
797     )
798 sc_prohibit_always_true_header_tests:
799         @or=$(gl_header_upper_case_or_);                                \
800         re="HAVE_($$or)_H";                                             \
801         prohibit='\<'"$$re"'\>'                                         \
802         halt=$$(printf '%s\n'                                           \
803         'do not test the above HAVE_<header>_H symbol(s);'              \
804         '  with the corresponding gnulib module, they are always true') \
805           $(_sc_search_regexp)
806
807 sc_prohibit_defined_have_decl_tests:
808         @prohibit='(#[   ]*ifn?def|\<defined)\>[         (]+HAVE_DECL_' \
809         halt='HAVE_DECL macros are always defined'                      \
810           $(_sc_search_regexp)
811
812 # ==================================================================
813 gl_other_headers_ ?= \
814   intprops.h    \
815   openat.h      \
816   stat-macros.h
817
818 # Perl -lne code to extract "significant" cpp-defined symbols from a
819 # gnulib header file, eliminating a few common false-positives.
820 # The exempted names below are defined only conditionally in gnulib,
821 # and hence sometimes must/may be defined in application code.
822 gl_extract_significant_defines_ = \
823   /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
824     && $$2 !~ /(?:rpl_|_used_without_)/\
825     && $$1 !~ /^(?:NSIG|ENODATA)$$/\
826     && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
827     and print $$1
828
829 # Create a list of regular expressions matching the names
830 # of macros that are guaranteed to be defined by parts of gnulib.
831 define def_sym_regex
832         gen_h=$(gl_generated_headers_);                                 \
833         (cd $(gnulib_dir)/lib;                                          \
834           for f in *.in.h $(gl_other_headers_); do                      \
835             test -f $$f                                                 \
836               && perl -lne '$(gl_extract_significant_defines_)' $$f;    \
837           done;                                                         \
838         ) | sort -u                                                     \
839           | $(SED) 's/^/^ *# *(define|undef)  */;s/$$/\\>/'
840 endef
841
842 # Don't define macros that we already get from gnulib header files.
843 sc_prohibit_always-defined_macros:
844         @if test -d $(gnulib_dir); then                                 \
845           case $$(echo all: | grep -l -f - Makefile) in Makefile);; *)  \
846             echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
847           esac;                                                         \
848           $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT))         \
849             && { echo '$(ME): define the above via some gnulib .h file' \
850                   1>&2;  exit 1; } || :;                                \
851         fi
852 # ==================================================================
853
854 # Prohibit checked in backup files.
855 sc_prohibit_backup_files:
856         @$(VC_LIST) | grep '~$$' &&                             \
857           { echo '$(ME): found version controlled backup file' 1>&2;    \
858             exit 1; } || :
859
860 # Require the latest GPL.
861 sc_GPL_version:
862         @prohibit='either ''version [^3]'                               \
863         halt='GPL vN, N!=3'                                             \
864           $(_sc_search_regexp)
865
866 # Require the latest GFDL.  Two regexp, since some .texi files end up
867 # line wrapping between 'Free Documentation License,' and 'Version'.
868 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
869 sc_GFDL_version:
870         @prohibit='$(_GFDL_regexp)'                                     \
871         halt='GFDL vN, N!=3'                                            \
872           $(_sc_search_regexp)
873
874 # Don't use Texinfo's @acronym{}.
875 # https://lists.gnu.org/r/bug-gnulib/2010-03/msg00321.html
876 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
877 sc_texinfo_acronym:
878         @prohibit='@acronym\{'                                          \
879         in_vc_files='$(texinfo_suffix_re_)'                             \
880         halt='found use of Texinfo @acronym{}'                          \
881           $(_sc_search_regexp)
882
883 cvs_keywords = \
884   Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
885
886 sc_prohibit_cvs_keyword:
887         @prohibit='\$$($(cvs_keywords))\$$'                             \
888         halt='do not use CVS keyword expansion'                         \
889           $(_sc_search_regexp)
890
891 # This Perl code is slightly obfuscated.  Not only is each "$" doubled
892 # because it's in a Makefile, but the $$c's are comments;  we cannot
893 # use "#" due to the way the script ends up concatenated onto one line.
894 # It would be much more concise, and would produce better output (including
895 # counts) if written as:
896 #   perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
897 # but that would be far less efficient, reading the entire contents
898 # of each file, rather than just the last two bytes of each.
899 # In addition, while the code below detects both blank lines and a missing
900 # newline at EOF, the above detects only the former.
901 #
902 # This is a perl script that is expected to be the single-quoted argument
903 # to a command-line "-le".  The remaining arguments are file names.
904 # Print the name of each file that does not end in exactly one newline byte.
905 # I.e., warn if there are blank lines (2 or more newlines), or if the
906 # last byte is not a newline.  However, currently we don't complain
907 # about any file that contains exactly one byte.
908 # Exit nonzero if at least one such file is found, otherwise, exit 0.
909 # Warn about, but otherwise ignore open failure.  Ignore seek/read failure.
910 #
911 # Use this if you want to remove trailing empty lines from selected files:
912 #   perl -pi -0777 -e 's/\n\n+$/\n/' files...
913 #
914 require_exactly_one_NL_at_EOF_ =                                        \
915   foreach my $$f (@ARGV)                                                \
916     {                                                                   \
917       open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next;     \
918       my $$p = sysseek (F, -2, 2);                                      \
919       my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
920       my $$last_two_bytes;                                              \
921       defined $$p and $$p = sysread F, $$last_two_bytes, 2;             \
922       close F;                                                          \
923       $$c = "ignore read failure";                                      \
924       $$p && ($$last_two_bytes eq "\n\n"                                \
925               || substr ($$last_two_bytes,1) ne "\n")                   \
926           and (print $$f), $$fail=1;                                    \
927     }                                                                   \
928   END { exit defined $$fail }
929 sc_prohibit_empty_lines_at_EOF:
930         @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
931           || { echo '$(ME): empty line(s) or no newline at EOF'         \
932                 1>&2; exit 1; } || :
933
934 # Make sure we don't use st_blocks.  Use ST_NBLOCKS instead.
935 # This is a bit of a kludge, since it prevents use of the string
936 # even in comments, but for now it does the job with no false positives.
937 sc_prohibit_stat_st_blocks:
938         @prohibit='[.>]st_blocks'                                       \
939         halt='do not use st_blocks; use ST_NBLOCKS'                     \
940           $(_sc_search_regexp)
941
942 # Make sure we don't define any S_IS* macros in src/*.c files.
943 # They're already defined via gnulib's sys/stat.h replacement.
944 sc_prohibit_S_IS_definition:
945         @prohibit='^ *# *define  *S_IS'                                 \
946         halt='do not define S_IS* macros; include <sys/stat.h>'         \
947           $(_sc_search_regexp)
948
949 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
950 # that is shared by two definitions below.
951 perl_filename_lineno_text_ =                                            \
952     -e '  {'                                                            \
953     -e '    $$n = ($$` =~ tr/\n/\n/ + 1);'                              \
954     -e '    ($$v = $$&) =~ s/\n/\\n/g;'                                 \
955     -e '    print "$$ARGV:$$n:$$v\n";'                                  \
956     -e '  }'
957
958 prohibit_doubled_words_ = \
959     the then in an on if is it but for or at and do to
960 # expand the regex before running the check to avoid using expensive captures
961 prohibit_doubled_word_expanded_ = \
962     $(join $(prohibit_doubled_words_),$(addprefix \s+,$(prohibit_doubled_words_)))
963 prohibit_doubled_word_RE_ ?= \
964     /\b(?:$(subst $(_sp),|,$(prohibit_doubled_word_expanded_)))\b/gims
965 prohibit_doubled_word_ =                                                \
966     -e 'while ($(prohibit_doubled_word_RE_))'                           \
967     $(perl_filename_lineno_text_)
968
969 # Define this to a regular expression that matches
970 # any filename:dd:match lines you want to ignore.
971 # The default is to ignore no matches.
972 ignore_doubled_word_match_RE_ ?= ^$$
973
974 sc_prohibit_doubled_word:
975         @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT))  \
976           | grep -vE '$(ignore_doubled_word_match_RE_)'                 \
977           | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
978
979 # A regular expression matching undesirable combinations of words like
980 # "can not"; this matches them even when the two words appear on different
981 # lines, but not when there is an intervening delimiter like "#" or "*".
982 # Similarly undesirable, "See @xref{...}", since an @xref should start
983 # a sentence.  Explicitly prohibit any prefix of "see" or "also".
984 # Also prohibit a prefix matching "\w+ +".
985 # @pxref gets the same see/also treatment and should be parenthesized;
986 # presume it must *not* start a sentence.
987 # POSIX spells it "timestamp" rather than "time\s+stamp", so we do, too.
988 bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
989 bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
990 prohibit_undesirable_word_seq_RE_ ?=                                    \
991   /(?:\bcan\s+not\b|\btime\s+stamps?\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
992 prohibit_undesirable_word_seq_ =                                        \
993     -e 'while ($(prohibit_undesirable_word_seq_RE_))'                   \
994     $(perl_filename_lineno_text_)
995 # Define this to a regular expression that matches
996 # any filename:dd:match lines you want to ignore.
997 # The default is to ignore no matches.
998 ignore_undesirable_word_sequence_RE_ ?= ^$$
999
1000 sc_prohibit_undesirable_word_seq:
1001         @perl -n -0777 $(prohibit_undesirable_word_seq_)                \
1002              $$($(VC_LIST_EXCEPT))                                      \
1003           | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
1004           && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
1005
1006 # Except for shell files and for loops, double semicolon is probably a mistake
1007 sc_prohibit_double_semicolon:
1008         @prohibit='; *;[        {} \]*(/[/*]|$$)'                       \
1009         in_vc_files='\.[chly]$$'                                        \
1010         exclude='\bfor *\(.*\)'                                         \
1011         halt="Double semicolon detected"                                \
1012           $(_sc_search_regexp)
1013
1014 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
1015 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
1016 # Using test's -a and -o operators is not portable.
1017 # We prefer test over [, since the latter is spelled [[ in configure.ac.
1018 sc_prohibit_test_minus_ao:
1019         @prohibit='(\<test| \[+) .+ -[ao] '                             \
1020         halt='$(_ptm1); $(_ptm2)'                                       \
1021           $(_sc_search_regexp)
1022
1023 # Avoid a test bashism.
1024 sc_prohibit_test_double_equal:
1025         @prohibit='(\<test| \[+) .+ == '                                \
1026         containing='#! */bin/[a-z]*sh'                                  \
1027         halt='use "test x = x", not "test x =''= x"'                    \
1028           $(_sc_search_regexp)
1029
1030 # Each program that uses proper_name_utf8 must link with one of the
1031 # ICONV libraries.  Otherwise, some ICONV library must appear in LDADD.
1032 # The perl -0777 invocation below extracts the possibly-multi-line
1033 # definition of LDADD from the appropriate Makefile.am and exits 0
1034 # when it contains "ICONV".
1035 sc_proper_name_utf8_requires_ICONV:
1036         @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
1037         if test "x$$progs" != x; then                                   \
1038           fail=0;                                                       \
1039           for p in $$progs; do                                          \
1040             dir=$$(dirname "$$p");                                      \
1041             perl -0777                                                  \
1042               -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)'  \
1043               $$dir/Makefile.am && continue;                            \
1044             base=$$(basename "$$p" .c);                                 \
1045             grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
1046               || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
1047           done;                                                         \
1048           test $$fail = 1 &&                                            \
1049             { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
1050               exit 1; } || :;                                           \
1051         fi
1052
1053 # Warn about "c0nst struct Foo const foo[]",
1054 # but not about "char const *const foo" or "#define const const".
1055 sc_redundant_const:
1056         @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'          \
1057         halt='redundant "const" in declarations'                        \
1058           $(_sc_search_regexp)
1059
1060 sc_const_long_option:
1061         @prohibit='^ *static.*struct option '                           \
1062         exclude='const struct option|struct option const'               \
1063         halt='add "const" to the above declarations'                    \
1064           $(_sc_search_regexp)
1065
1066 NEWS_hash =                                                             \
1067   $$($(SED) -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p'           \
1068        $(srcdir)/NEWS                                                   \
1069      | perl -0777 -pe                                                   \
1070         's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms'       \
1071      | md5sum -                                                         \
1072      | $(SED) 's/ .*//')
1073
1074 # Ensure that we don't accidentally insert an entry into an old NEWS block.
1075 sc_immutable_NEWS:
1076         @if test -f $(srcdir)/NEWS; then                                \
1077           test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : ||              \
1078             { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
1079         fi
1080
1081 # Update the hash stored above.  Do this after each release and
1082 # for any corrections to old entries.
1083 update-NEWS-hash: NEWS
1084         perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1085           $(srcdir)/cfg.mk
1086
1087 # Ensure that we use only the standard $(VAR) notation,
1088 # not @...@ in Makefile.am, now that we can rely on automake
1089 # to emit a definition for each substituted variable.
1090 # However, there is still one case in which @VAR@ use is not just
1091 # legitimate, but actually required: when augmenting an automake-defined
1092 # variable with a prefix.  For example, gettext uses this:
1093 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1094 # otherwise, makeinfo would put German or French (current locale)
1095 # navigation hints in the otherwise-English documentation.
1096 #
1097 # Allow the package to add exceptions via a hook in cfg.mk;
1098 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1099 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1100 _makefile_at_at_check_exceptions ?=
1101 sc_makefile_at_at_check:
1102         @perl -ne '/\@\w+\@/'                                           \
1103           -e ' && !/(\w+)\s+=.*\@\1\@$$/'                               \
1104           -e ''$(_makefile_at_at_check_exceptions)                      \
1105           -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'    \
1106             $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1107           && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1108
1109 news-check: NEWS
1110         $(AM_V_GEN)if $(SED) -n $(news-check-lines-spec)p $<            \
1111             | grep -E $(news-check-regexp) >/dev/null; then             \
1112           :;                                                            \
1113         else                                                            \
1114           echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2;      \
1115           exit 1;                                                       \
1116         fi
1117
1118 sc_makefile_TAB_only_indentation:
1119         @prohibit='^    [ ]{8}'                                         \
1120         in_vc_files='akefile|\.mk$$'                                    \
1121         halt='found TAB-8-space indentation'                            \
1122           $(_sc_search_regexp)
1123
1124 sc_m4_quote_check:
1125         @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'              \
1126         in_vc_files='(^configure\.ac|\.m4)$$'                           \
1127         halt='quote the first arg to AC_DEF*'                           \
1128           $(_sc_search_regexp)
1129
1130 fix_po_file_diag = \
1131 'you have changed the set of files with translatable diagnostics;\n\
1132 apply the above patch\n'
1133
1134 # Generate a list of files in which to search for translatable strings.
1135 perl_translatable_files_list_ =                                         \
1136   -e 'foreach $$file (@ARGV) {'                                         \
1137   -e '  \# Consider only file extensions with one or two letters'       \
1138   -e '  $$file =~ /\...?$$/ or next;'                                   \
1139   -e '  \# Ignore m4 and mk files'                                      \
1140   -e '  $$file =~ /\.m[4k]$$/ and next;'                                \
1141   -e '  \# Ignore a .c or .h file with a corresponding .l or .y file'   \
1142   -e '  $$file =~ /(.+)\.[ch]$$/ && (-e "$${1}.l" || -e "$${1}.y")'     \
1143   -e '    and next;'                                                    \
1144   -e '  \# Skip unreadable files'                                       \
1145   -e '  -r $$file or next;'                                             \
1146   -e '  print "$$file ";'                                               \
1147   -e '}'
1148
1149 # Verify that all source files using _() (more specifically, files that
1150 # match $(_gl_translatable_string_re)) are listed in po/POTFILES.in.
1151 po_file ?= $(srcdir)/po/POTFILES.in
1152 generated_files ?= $(srcdir)/lib/*.[ch]
1153 _gl_translatable_string_re ?= \b(N?_|gettext *)\([^)"]*("|$$)
1154 sc_po_check:
1155         @if test -f $(po_file); then                                    \
1156           grep -E -v '^(#|$$)' $(po_file)                               \
1157             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
1158           files=$$(perl $(perl_translatable_files_list_)                \
1159             $$($(VC_LIST_EXCEPT)) $(generated_files));                  \
1160           grep -E -l '$(_gl_translatable_string_re)' $$files            \
1161             | $(SED) 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2;   \
1162           diff -u -L $(po_file) -L $(po_file) $@-1 $@-2                 \
1163             || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };   \
1164           rm -f $@-1 $@-2;                                              \
1165         fi
1166
1167 # Sometimes it is useful to change the PATH environment variable
1168 # in Makefiles.  When doing so, it's better not to use the Unix-centric
1169 # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1170 msg = 'Do not use ":" above; use $$(PATH_SEPARATOR) instead'
1171 sc_makefile_path_separator_check:
1172         @prohibit='PATH[=].*:'                                          \
1173         in_vc_files='akefile|\.mk$$'                                    \
1174         halt=$(msg)                                                     \
1175           $(_sc_search_regexp)
1176
1177 # Check that 'make alpha' will not fail at the end of the process,
1178 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1179 # and is read-only.
1180 writable-files:
1181         $(AM_V_GEN)if test -d $(release_archive_dir); then              \
1182           for file in $(DIST_ARCHIVES); do                              \
1183             for p in ./ $(release_archive_dir)/; do                     \
1184               test -e $$p$$file || continue;                            \
1185               test -w $$p$$file                                         \
1186                 || { echo ERROR: $$p$$file is not writable; fail=1; };  \
1187             done;                                                       \
1188           done;                                                         \
1189           test "$$fail" && exit 1 || : ;                                \
1190         else :;                                                         \
1191         fi
1192
1193 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1194 sample-test = tests/sample-test
1195 texi = doc/$(PACKAGE).texi
1196 # Make sure that the copyright date in $(v_etc_file) is up to date.
1197 # Do the same for the $(sample-test) and the main doc/.texi file.
1198 sc_copyright_check:
1199         @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };'            \
1200         in_files=$(v_etc_file)                                          \
1201         halt='out of date copyright in $(v_etc_file); update it'        \
1202           $(_sc_search_regexp)
1203         @require='# Copyright \(C\) '$$(date +%Y)' Free'                \
1204         in_vc_files=$(sample-test)                                      \
1205         halt='out of date copyright in $(sample-test); update it'       \
1206           $(_sc_search_regexp)
1207         @require='Copyright @copyright\{\} .*'$$(date +%Y)              \
1208         in_vc_files=$(texi)                                             \
1209         halt='out of date copyright in $(texi); update it'              \
1210           $(_sc_search_regexp)
1211
1212 # If tests/help-version exists and seems to be new enough, assume that its
1213 # use of init.sh and path_prepend_ is correct, and ensure that every other
1214 # use of init.sh is identical.
1215 # This is useful because help-version cross-checks prog --version
1216 # with $(VERSION), which verifies that its path_prepend_ invocation
1217 # sets PATH correctly.  This is an inexpensive way to ensure that
1218 # the other init.sh-using tests also get it right.
1219 _hv_file ?= $(srcdir)/tests/help-version
1220 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1221 # Fix syntax-highlighters "
1222 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1223 sc_cross_check_PATH_usage_in_tests:
1224         @if test -f $(_hv_file); then                                   \
1225           grep -l 'VERSION mismatch' $(_hv_file) >/dev/null             \
1226             || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2;    \
1227                  exit 0; };                                             \
1228           grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null         \
1229             || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1230                  exit 1; };                                             \
1231           good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file));           \
1232           grep -LFx "$$good"                                            \
1233                 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT)))  \
1234               | grep . &&                                               \
1235             { echo "$(ME): the above files use path_prepend_ inconsistently" \
1236                 1>&2; exit 1; } || :;                                   \
1237         fi
1238
1239 # BRE regex of file contents to identify a test script.
1240 _test_script_regex ?= \<init\.sh\>
1241
1242 # In tests, use "compare expected actual", not the reverse.
1243 sc_prohibit_reversed_compare_failure:
1244         @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)'                \
1245         containing='$(_test_script_regex)'                              \
1246         halt='reversed compare arguments'                               \
1247           $(_sc_search_regexp)
1248
1249 # #if HAVE_... will evaluate to false for any non numeric string.
1250 # That would be flagged by using -Wundef, however gnulib currently
1251 # tests many undefined macros, and so we can't enable that option.
1252 # So at least preclude common boolean strings as macro values.
1253 sc_Wundef_boolean:
1254         @prohibit='^#define.*(yes|no|true|false)$$'                     \
1255         in_files='$(CONFIG_INCLUDE)'                                    \
1256         halt='Use 0 or 1 for macro values'                              \
1257           $(_sc_search_regexp)
1258
1259 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1260 # not be constant, or might overflow a stack.  In general, use PATH_MAX as
1261 # a limit, not an array or alloca size.
1262 sc_prohibit_path_max_allocation:
1263         @prohibit='(\balloca *\([^)]*|\[[^]]*)\bPATH_MAX'               \
1264         halt='Avoid stack allocations of size PATH_MAX'                 \
1265           $(_sc_search_regexp)
1266
1267 sc_vulnerable_makefile_CVE-2009-4029:
1268         @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1269         in_files='(^|/)Makefile\.in$$'                                  \
1270         halt=$$(printf '%s\n'                                           \
1271           'the above files are vulnerable; beware of running'           \
1272           '  "make dist*" rules, and upgrade to fixed automake'         \
1273           '  see https://bugzilla.redhat.com/show_bug.cgi?id=542609 for details') \
1274           $(_sc_search_regexp)
1275
1276 sc_vulnerable_makefile_CVE-2012-3386:
1277         @prohibit='chmod a\+w \$$\(distdir\)'                           \
1278         in_files='(^|/)Makefile\.in$$'                                  \
1279         halt=$$(printf '%s\n'                                           \
1280           'the above files are vulnerable; beware of running'           \
1281           '  "make distcheck", and upgrade to fixed automake'           \
1282           '  see https://bugzilla.redhat.com/show_bug.cgi?id=CVE-2012-3386 for details') \
1283           $(_sc_search_regexp)
1284
1285 vc-diff-check:
1286         $(AM_V_GEN)(unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1287         $(AM_V_at)if test -s vc-diffs; then                     \
1288           cat vc-diffs;                                         \
1289           echo "Some files are locally modified:" 1>&2;         \
1290           exit 1;                                               \
1291         else                                                    \
1292           rm vc-diffs;                                          \
1293         fi
1294
1295 rel-files = $(DIST_ARCHIVES)
1296
1297 gnulib-version = $$(cd $(gnulib_dir)                            \
1298                     && { git describe || git rev-parse --short=10 HEAD; } )
1299 bootstrap-tools ?= autoconf,automake,gnulib
1300
1301 gpgv = $$(gpgv2 --version >/dev/null && echo gpgv2 || echo gpgv)
1302 # If it's not already specified, derive the GPG key ID from
1303 # the signed tag we've just applied to mark this release.
1304 gpg_key_ID ?=                                                           \
1305   $$(cd $(srcdir)                                                       \
1306      && git cat-file tag v$(VERSION)                                    \
1307         | $(gpgv) --status-fd 1 --keyring /dev/null - - 2>/dev/null     \
1308         | awk '/^\[GNUPG:\] ERRSIG / {print $$3; exit}')
1309
1310 translation_project_ ?= coordinator@translationproject.org
1311
1312 # Make info-gnu the default only for a stable release.
1313 announcement_Cc_stable = $(translation_project_), $(PACKAGE_BUGREPORT)
1314 announcement_mail_headers_stable =              \
1315   To: info-gnu@gnu.org                          \
1316   Cc: $(announcement_Cc_)                       \
1317   Mail-Followup-To: $(PACKAGE_BUGREPORT)
1318
1319 announcement_Cc_alpha = $(translation_project_)
1320 announcement_mail_headers_alpha =               \
1321   To: $(PACKAGE_BUGREPORT)                      \
1322   Cc: $(announcement_Cc_)
1323
1324 announcement_mail_Cc_beta = $(announcement_mail_Cc_alpha)
1325 announcement_mail_headers_beta = $(announcement_mail_headers_alpha)
1326
1327 announcement_mail_Cc_ ?= $(announcement_mail_Cc_$(release-type))
1328 announcement_mail_headers_ ?= $(announcement_mail_headers_$(release-type))
1329 announcement: NEWS ChangeLog $(rel-files)
1330 # Not $(AM_V_GEN) since the output of this command serves as
1331 # announcement message: it would start with " GEN announcement".
1332         $(AM_V_at)$(srcdir)/$(_build-aux)/announce-gen                  \
1333             --mail-headers='$(announcement_mail_headers_)'              \
1334             --release-type=$(release-type)                              \
1335             --package=$(PACKAGE)                                        \
1336             --prev=$(PREV_VERSION)                                      \
1337             --curr=$(VERSION)                                           \
1338             --gpg-key-id=$(gpg_key_ID)                                  \
1339             --srcdir=$(srcdir)                                          \
1340             --news=$(srcdir)/NEWS                                       \
1341             --bootstrap-tools=$(bootstrap-tools)                        \
1342             $$(case ,$(bootstrap-tools), in (*,gnulib,*)                \
1343                echo --gnulib-version=$(gnulib-version);; esac)          \
1344             --no-print-checksums                                        \
1345             $(addprefix --url-dir=, $(url_dir_list))
1346
1347 .PHONY: release-commit
1348 release-commit:
1349         $(AM_V_GEN)cd $(srcdir)                         \
1350           && $(_build-aux)/do-release-commit-and-tag    \
1351                -C $(abs_builddir) $(RELEASE)
1352
1353 ## ---------------- ##
1354 ## Updating files.  ##
1355 ## ---------------- ##
1356
1357 ftp-gnu = https://ftp.gnu.org/gnu
1358 www-gnu = https://www.gnu.org
1359
1360 upload_dest_dir_ ?= $(PACKAGE)
1361 upload_command =                                                \
1362   $(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS)             \
1363   --to $(gnu_rel_host):$(upload_dest_dir_)                      \
1364   $(rel-files)
1365 emit_upload_commands:
1366         @echo =====================================
1367         @echo =====================================
1368         @echo '$(upload_command)'
1369         @echo '# send the ~/announce-$(my_distdir) e-mail'
1370         @echo =====================================
1371         @echo =====================================
1372
1373 .PHONY: upload
1374 upload:
1375         $(AM_V_GEN)$(upload_command)
1376
1377 define emit-commit-log
1378   printf '%s\n' 'maint: post-release administrivia' ''                  \
1379     '* NEWS: Add header line for next release.'                         \
1380     '* .prev-version: Record previous version.'                         \
1381     '* cfg.mk (old_NEWS_hash): Auto-update.'
1382 endef
1383
1384 .PHONY: no-submodule-changes
1385 no-submodule-changes:
1386         $(AM_V_GEN)if test -d $(srcdir)/.git                            \
1387                 && git --version >/dev/null 2>&1; then                  \
1388           diff=$$(cd $(srcdir) && git submodule -q foreach              \
1389                   git diff-index --name-only HEAD)                      \
1390             || exit 1;                                                  \
1391           case $$diff in '') ;;                                         \
1392             *) echo '$(ME): submodule files are locally modified:';     \
1393                 echo "$$diff"; exit 1;; esac;                           \
1394         else                                                            \
1395           : ;                                                           \
1396         fi
1397
1398 submodule-checks ?= no-submodule-changes public-submodule-commit
1399
1400 # Ensure that each sub-module commit we're using is public.
1401 # Without this, it is too easy to tag and release code that
1402 # cannot be built from a fresh clone.
1403 .PHONY: public-submodule-commit
1404 public-submodule-commit:
1405         $(AM_V_GEN)if test -d $(srcdir)/.git                            \
1406                 && git --version >/dev/null 2>&1; then                  \
1407           cd $(srcdir) &&                                               \
1408           git submodule --quiet foreach                                 \
1409               'test "$$(git rev-parse "$$sha1")"                        \
1410                   = "$$(git merge-base origin "$$sha1")"'               \
1411             || { echo '$(ME): found non-public submodule commit' >&2;   \
1412                  exit 1; };                                             \
1413         else                                                            \
1414           : ;                                                           \
1415         fi
1416 # This rule has a high enough utility/cost ratio that it should be a
1417 # dependent of "check" by default.  However, some of us do occasionally
1418 # commit a temporary change that deliberately points to a non-public
1419 # submodule commit, and want to be able to use rules like "make check".
1420 # In that case, run e.g., "make check gl_public_submodule_commit="
1421 # to disable this test.
1422 gl_public_submodule_commit ?= public-submodule-commit
1423 check: $(gl_public_submodule_commit)
1424
1425 .PHONY: alpha beta stable release
1426 ALL_RECURSIVE_TARGETS += alpha beta stable
1427 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1428         $(AM_V_GEN)test $@ = stable                                     \
1429           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$'         \
1430                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1431           || :
1432         $(AM_V_at)$(MAKE) vc-diff-check
1433         $(AM_V_at)$(MAKE) news-check
1434         $(AM_V_at)$(MAKE) distcheck
1435         $(AM_V_at)$(MAKE) dist
1436         $(AM_V_at)$(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1437         $(AM_V_at)$(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1438
1439 release:
1440         $(AM_V_GEN)$(MAKE) _version
1441         $(AM_V_GEN)$(MAKE) $(release-type)
1442
1443 # Override this in cfg.mk if you follow different procedures.
1444 release-prep-hook ?= release-prep
1445
1446 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1447 .PHONY: release-prep
1448 release-prep:
1449         $(AM_V_GEN)$(MAKE) --no-print-directory -s announcement \
1450           > ~/announce-$(my_distdir)
1451         $(AM_V_at)if test -d $(release_archive_dir); then       \
1452           ln $(rel-files) $(release_archive_dir);               \
1453           chmod a-w $(rel-files);                               \
1454         fi
1455         $(AM_V_at)echo $(VERSION) > $(prev_version_file)
1456         $(AM_V_at)$(MAKE) update-NEWS-hash
1457         $(AM_V_at)perl -pi                                              \
1458           -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"'        \
1459           $(srcdir)/NEWS
1460         $(AM_V_at)msg=$$($(emit-commit-log)) || exit 1;         \
1461         cd $(srcdir) && $(VC) commit -m "$$msg" -a
1462
1463 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1464 # if the default $(PACKAGE)-derived name doesn't apply.
1465 gendocs_options_ ?=
1466
1467 .PHONY: web-manual
1468 web-manual:
1469         $(AM_V_GEN)test -z "$(manual_title)" \
1470           && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1471         $(AM_V_at)cd '$(srcdir)/doc'; \
1472           $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1473              -o '$(abs_builddir)/doc/manual' \
1474              --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1475             "$(PACKAGE_NAME) - $(manual_title)"
1476         $(AM_V_at)echo " *** Upload the doc/manual directory to web-cvs."
1477
1478 .PHONY: web-manual-update
1479 web-manual-update:
1480         $(AM_V_GEN)cd $(srcdir) \
1481           && $(_build-aux)/gnu-web-doc-update -C $(abs_builddir)
1482
1483
1484 # Code Coverage
1485
1486 init-coverage:
1487         $(MAKE) $(AM_MAKEFLAGS) clean
1488         lcov --directory . --zerocounters
1489
1490 COVERAGE_CCOPTS ?= "-g --coverage"
1491 COVERAGE_OUT ?= doc/coverage
1492
1493 build-coverage:
1494         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1495         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1496         mkdir -p $(COVERAGE_OUT)
1497         lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1498                 --capture
1499
1500 gen-coverage:
1501         genhtml --output-directory $(COVERAGE_OUT) \
1502                 $(COVERAGE_OUT)/$(PACKAGE).info \
1503                 --highlight --frames --legend \
1504                 --title "$(PACKAGE_NAME)"
1505
1506 coverage:
1507         $(MAKE) init-coverage
1508         $(MAKE) build-coverage
1509         $(MAKE) gen-coverage
1510
1511 # Some projects carry local adjustments for gnulib modules via patches in
1512 # a gnulib patch directory whose default name is gl/ (defined in bootstrap
1513 # via local_gl_dir=gl).  Those patches become stale as the originals evolve
1514 # in gnulib.  Use this rule to refresh any stale patches.  It applies each
1515 # patch to the original in $(gnulib_dir) and uses the temporary result to
1516 # generate a fuzz-free .diff file.  If you customize the name of your local
1517 # gnulib patch directory via bootstrap.conf, this rule detects that name.
1518 # Run this from a non-VPATH (i.e., srcdir) build directory.
1519 .PHONY: refresh-gnulib-patches
1520 refresh-gnulib-patches:
1521         gl=gl;                                                          \
1522         if test -f bootstrap.conf; then                                 \
1523           t=$$(perl -lne '/^\s*local_gl_dir=(\S+)/ and $$d=$$1;'        \
1524                -e 'END{defined $$d and print $$d}' bootstrap.conf);     \
1525           test -n "$$t" && gl=$$t;                                      \
1526         fi;                                                             \
1527         for diff in $$(cd $$gl; git ls-files | grep '\.diff$$'); do     \
1528           b=$$(printf %s "$$diff"|$(SED) 's/\.diff$$//');               \
1529           VERSION_CONTROL=none                                          \
1530             patch "$(gnulib_dir)/$$b" "$$gl/$$diff" || exit 1;          \
1531           ( cd $(gnulib_dir) || exit 1;                                 \
1532             git diff "$$b" > "../$$gl/$$diff";                          \
1533             git checkout $$b ) || exit 1;                               \
1534         done
1535
1536 # Update gettext files.
1537 PACKAGE ?= $(shell basename $(PWD))
1538 PO_DOMAIN ?= $(PACKAGE)
1539 POURL = https://translationproject.org/latest/$(PO_DOMAIN)/
1540 PODIR ?= po
1541 refresh-po:
1542         rm -f $(PODIR)/*.po && \
1543         echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1544         wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1545         echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1546         echo 'en@quot' >> $(PODIR)/LINGUAS && \
1547         ls $(PODIR)/*.po | $(SED) 's/\.po//;s,$(PODIR)/,,' | \
1548           sort >> $(PODIR)/LINGUAS
1549
1550  # Running indent once is not idempotent, but running it twice is.
1551 INDENT_SOURCES ?= $(C_SOURCES)
1552 .PHONY: indent
1553 indent:
1554         indent $(INDENT_SOURCES)
1555         indent $(INDENT_SOURCES)
1556
1557 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1558 # put the assignments in this variable.
1559 update-copyright-env ?=
1560
1561 # Run this rule once per year (usually early in January)
1562 # to update all FSF copyright year lists in your project.
1563 # If you have an additional project-specific rule,
1564 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1565 # By default, exclude all variants of COPYING; you can also
1566 # add exemptions (such as ChangeLog..* for rotated change logs)
1567 # in the file .x-update-copyright.
1568 .PHONY: update-copyright
1569 update-copyright:
1570         $(AM_V_GEN)grep -l -w Copyright                                  \
1571           $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1572           | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1573
1574 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1575 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1576
1577 # NOTE: to override any _gl_TS_* default value, you must
1578 # define the variable(s) using "export" in cfg.mk.
1579 _gl_TS_dir ?= src
1580
1581 ALL_RECURSIVE_TARGETS += sc_tight_scope
1582 sc_tight_scope: tight-scope.mk
1583         @fail=0;                                                        \
1584         if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk        \
1585                 > /dev/null                                             \
1586            && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1587                 > /dev/null 2>&1; then                                  \
1588             echo '$(ME): skipping $@';                                  \
1589         else                                                            \
1590             $(MAKE) -s -C $(_gl_TS_dir)                                 \
1591                 -f Makefile                                             \
1592                 -f $(abs_top_srcdir)/cfg.mk                             \
1593                 -f $(abs_top_builddir)/$<                               \
1594               _gl_tight_scope                                           \
1595                 || fail=1;                                              \
1596         fi;                                                             \
1597         rm -f $<;                                                       \
1598         exit $$fail
1599
1600 tight-scope.mk: $(ME)
1601         @rm -f $@ $@-t
1602         @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
1603         @chmod a=r $@-t && mv $@-t $@
1604
1605 ifeq (a,b)
1606 # TS-start
1607
1608 # Most functions should have static scope.
1609 # Any that don't must be marked with 'extern', but 'main'
1610 # and 'usage' are exceptions: they're always extern, but
1611 # do not need to be marked.  Symbols matching '__.*' are
1612 # reserved by the compiler, so are automatically excluded below.
1613 _gl_TS_unmarked_extern_functions ?= main usage
1614 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\w+) *\(/
1615
1616 # If your project uses a macro like "XTERN", then put
1617 # the following in cfg.mk to override this default:
1618 # export _gl_TS_extern = extern|XTERN
1619 _gl_TS_extern ?= extern
1620
1621 # The second nm|grep checks for file-scope variables with 'extern' scope.
1622 # Without gnulib's progname module, you might put program_name here.
1623 # Symbols matching '__.*' are reserved by the compiler,
1624 # so are automatically excluded below.
1625 _gl_TS_unmarked_extern_vars ?=
1626
1627 # NOTE: the _match variables are perl expressions -- not mere regular
1628 # expressions -- so that you can extend them to match other patterns
1629 # and easily extract matched variable names.
1630 # For example, if your project declares some global variables via
1631 # a macro like this: GLOBAL(type, var_name, initializer), then you
1632 # can override this definition to automatically extract those names:
1633 # export _gl_TS_var_match = \
1634 #   /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1635 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1636
1637 # The names of object files in (or relative to) $(_gl_TS_dir).
1638 _gl_TS_obj_files ?= *.$(OBJEXT)
1639
1640 # Files in which to search for the one-line style extern declarations.
1641 # $(_gl_TS_dir)-relative.
1642 _gl_TS_headers ?= $(noinst_HEADERS)
1643 _gl_TS_other_headers ?= *.h
1644
1645 .PHONY: _gl_tight_scope
1646 _gl_tight_scope: $(bin_PROGRAMS)
1647         sed_wrap='s/^/^_?/;s/$$/$$/';                                   \
1648         t=exceptions-$$$$;                                              \
1649         trap 's=$$?; rm -f $$t; exit $$s' 0;                            \
1650         for sig in 1 2 3 13 15; do                                      \
1651           eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1652         done;                                                           \
1653         src=`for f in $(SOURCES); do                                    \
1654                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1655         hdr=`for f in $(_gl_TS_headers); do                             \
1656                test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`;   \
1657         ( printf '%s\n' '__.*' $(_gl_TS_unmarked_extern_functions);     \
1658           grep -h -A1 '^extern .*[^;]$$' $$src                          \
1659             | grep -vE '^(extern |--|#)' | $(SED) 's/ .*//; /^$$/d';    \
1660           perl -lne                                                     \
1661              '$(_gl_TS_function_match) and print $$1' $$hdr;            \
1662         ) | sort -u | $(SED) "$$sed_wrap" > $$t;                        \
1663         nm -g $(_gl_TS_obj_files)|$(SED) -n 's/.* T //p'|grep -Ev -f $$t \
1664           && { echo the above functions should have static scope >&2;   \
1665                exit 1; } || : ;                                         \
1666         ( printf '%s\n' '__.*' main $(_gl_TS_unmarked_extern_vars);     \
1667           perl -lne '$(_gl_TS_var_match) and print $$1'                 \
1668                 $$hdr $(_gl_TS_other_headers)                           \
1669         ) | sort -u | $(SED) "$$sed_wrap" > $$t;                        \
1670         nm -g $(_gl_TS_obj_files) | $(SED) -n 's/.* [BCDGRS] //p'       \
1671             | sort -u | grep -Ev -f $$t                                 \
1672           && { echo the above variables should have static scope >&2;   \
1673                exit 1; } || :
1674 # TS-end
1675 endif